<template>
  <div>
    <div class="d-flex justify-space-between">
      <div style="width: 100px;">
        <v-select
          v-model="perPage"
          :label="$t('totalVisible')"
          :items="listPerPage"
          @change="getCompras"
          dense
        />
      </div>
      <div class="d-flex justify-end">
        <v-btn
          v-if="!esCompra"
          class="mt-2 mr-4"
          color="success"
          rounded
          small
          @click="nuevaCompra"
          :disabled="loading"
        >
          <v-icon>mdi-table-plus</v-icon>
          {{ $t('nuevaCompra') }}
        </v-btn>
        <v-btn
          class="mt-2 mr-4"
          color="primary"
          rounded
          small
          @click="refreshTable"
          :disabled="loading"
        >
          <v-icon>mdi-refresh</v-icon>
          {{ $t('actualizar') }}
        </v-btn>
        <v-pagination
          v-model="currentPage"
          :disabled="loading"
          :length="lastPage"
          :total-visible="8"
        />
      </div>
    </div>
    <v-data-table
      v-model="selected"
      :headers="headers"
      :items="comprasData"
      item-key="id"
      class="elevation-1"
      disable-pagination
      hide-default-footer
      dense
      :loading="loading"
      :single-expand="singleExpand"
      show-expand
    >
      <template v-slot:expanded-item="{ headers, item }">
        <td :colspan="headers.length">
          <SubDetalleCompra :items="item.detalle_compras"/>
        </td>
      </template>
      <template v-if="esCompra" v-slot:item.actions="{ item }">
        <v-btn
          small
          icon
          @click="agregarCompra(item)"
        >
          <v-icon>mdi-cart-plus</v-icon>
        </v-btn>
      </template>
    </v-data-table>
  </div>
</template>

<script>
import CompraServicio from '@/store/services/CompraServicio'
import SubDetalleCompra from './SubDetalleCompra'
export default {
  name: "Compras",
  components: {
    SubDetalleCompra
  },
  props: {
    esCompra: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      expanded: [],
      singleExpand: false,
      listPerPage: [5, 10, 50, this.$t('todo')],
      perPage: 50,
      lastPage: 0,
      total: 0,
      currentPage: 1,
      comprasData: [],
      selected: [],
      loading: false,
      colorEstado: 'success'
    }
  },
  methods: {
    verifyType(value) {
      return typeof value;
    },
    async getCompras() {
      this.loading = true;
      const params = {
        page: this.currentPage,
        order_by: 'created_at',
        order_direction: 'DESC',
        per_page:
          this.verifyType(this.perPage) === 'string'
            ? this.total
            : this.perPage,
      }
      try {
        let response = await CompraServicio.index(params)
        this.comprasData = response.data.data;
        this.currentPage = response.data.current_page;
        this.lastPage = response.data.last_page;
        this.total = response.data.total;
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          console.log(error.response.message)
        }
      }
    },
    refreshTable() {
      this.resetCurrentPage();
    },
    resetCurrentPage() {
      if (this.currentPage === 1) this.getCompras();
      else this.currentPage = 1;
    },
    nuevaCompra() {
      this.$emit('onNuevaCompra');
    },
    agregarCompra(value) {
      this.$emit('onAgregarCompra', value)
    }
  },
  computed: {
    headers() {
      return [
        {
          value: 'actions',
          sortable: false,
        },
        {
          text: this.$t('codigo'),
          value: 'id',
          sortable: false,
        },
        {
          text: this.$t('usuario'),
          value: 'usuario.name',
          sortable: false,
        },
        {
          text: this.$t('area'),
          value: 'usuario.area',
          sortable: false,
        },
        {
          text: this.$t('factura'),
          value: 'factura',
          sortable: false,
        },
        {
          text: this.$t('fechaCompra'),
          value: 'fecha_compra',
          sortable: false,
        },
      ];
    },
  },
  watch: {
    currentPage() {
      this.getCompras();
    },
  },
  created() {
    this.getCompras()
  }
}
</script>

<style>

</style>
